/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSCustomImageRep;

import dstep.appkit.NSImageRep;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSCustomImageRep : NSImageRep
{
	mixin (ObjcWrap);

	NSCustomImageRep initWithDrawSelector (SEL aMethod, Object anObject)
	{
		id result = invokeObjcSelf!(id, "initWithDrawSelector:delegate:", SEL, Object)(aMethod, anObject);
		return result is this.objcObject ? this : (result !is null ? new NSCustomImageRep(result) : null);
	}

	this (SEL aMethod, Object anObject)
	{
		super(NSCustomImageRep.alloc.initWithDrawSelector(aMethod, anObject).objcObject);
	}

	SEL drawSelector ()
	{
		return invokeObjcSelf!(SEL, "drawSelector");
	}

	Object delegate_ ()
	{
		return invokeObjcSelf!(Object, "delegate");
	}
}

