/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSLevelIndicator;

import dstep.appkit.NSControl;
import dstep.appkit.NSLevelIndicatorCell;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObjCRuntime;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSLevelIndicator : NSControl
{
	mixin (ObjcWrap);

	double minValue ()
	{
		return invokeObjcSelf!(double, "minValue");
	}

	void setMinValue (double minValue)
	{
		return invokeObjcSelf!(void, "setMinValue:", double)(minValue);
	}

	double maxValue ()
	{
		return invokeObjcSelf!(double, "maxValue");
	}

	void setMaxValue (double maxValue)
	{
		return invokeObjcSelf!(void, "setMaxValue:", double)(maxValue);
	}

	double warningValue ()
	{
		return invokeObjcSelf!(double, "warningValue");
	}

	void setWarningValue (double warningValue)
	{
		return invokeObjcSelf!(void, "setWarningValue:", double)(warningValue);
	}

	double criticalValue ()
	{
		return invokeObjcSelf!(double, "criticalValue");
	}

	void setCriticalValue (double criticalValue)
	{
		return invokeObjcSelf!(void, "setCriticalValue:", double)(criticalValue);
	}

	uint tickMarkPosition ()
	{
		return invokeObjcSelf!(uint, "tickMarkPosition");
	}

	void setTickMarkPosition (uint position)
	{
		return invokeObjcSelf!(void, "setTickMarkPosition:", uint)(position);
	}

	NSInteger numberOfTickMarks ()
	{
		return invokeObjcSelf!(NSInteger, "numberOfTickMarks");
	}

	void setNumberOfTickMarks (NSInteger count)
	{
		return invokeObjcSelf!(void, "setNumberOfTickMarks:", NSInteger)(count);
	}

	NSInteger numberOfMajorTickMarks ()
	{
		return invokeObjcSelf!(NSInteger, "numberOfMajorTickMarks");
	}

	void setNumberOfMajorTickMarks (NSInteger count)
	{
		return invokeObjcSelf!(void, "setNumberOfMajorTickMarks:", NSInteger)(count);
	}

	double tickMarkValueAtIndex (NSInteger index)
	{
		return invokeObjcSelf!(double, "tickMarkValueAtIndex:", NSInteger)(index);
	}

	NSRect rectOfTickMarkAtIndex (NSInteger index)
	{
		return invokeObjcSelf!(NSRect, "rectOfTickMarkAtIndex:", NSInteger)(index);
	}
}

