/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSShadow;

import dstep.appkit.NSColor;
import dstep.foundation.NSCoder;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObject;
import dstep.foundation.NSZone;
import dstep.applicationservices.coregraphics.CGBase;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSShadow : NSObject, INSCopying, INSCoding
{
	mixin (ObjcWrap);
	
	this (NSCoder aDecoder)
	{
		super(typeof(this).alloc.initWithCoder(aDecoder).objcObject);
	}
	
	void encodeWithCoder (NSCoder aCoder)
	{
		return invokeObjcSelf!(void, "encodeWithCoder:", NSCoder)(aCoder);
	}
	
	typeof(this) initWithCoder (NSCoder aDecoder)
	{
		return invokeObjcSelf!(typeof(this), "initWithCoder:", NSCoder)(aDecoder);
	}
	
	typeof(this) copyWithZone (NSZone* zone)
	{
		return invokeObjcSelf!(typeof(this), "copyWithZone:", NSZone*)(zone);
	}

	NSShadow init ()
	{
		id result = invokeObjcSelf!(id, "init");
		return result is this.objcObject ? this : (result !is null ? new NSShadow(result) : null);
	}

	this ()
	{
		super(NSShadow.alloc.init.objcObject);
	}

	NSSize shadowOffset ()
	{
		return invokeObjcSelf!(NSSize, "shadowOffset");
	}

	void setShadowOffset (NSSize offset)
	{
		return invokeObjcSelf!(void, "setShadowOffset:", NSSize)(offset);
	}

	CGFloat shadowBlurRadius ()
	{
		return invokeObjcSelf!(CGFloat, "shadowBlurRadius");
	}

	void setShadowBlurRadius (CGFloat val)
	{
		return invokeObjcSelf!(void, "setShadowBlurRadius:", CGFloat)(val);
	}

	NSColor shadowColor ()
	{
		return invokeObjcSelf!(NSColor, "shadowColor");
	}

	void setShadowColor (NSColor color)
	{
		return invokeObjcSelf!(void, "setShadowColor:", NSColor)(color);
	}

	void set ()
	{
		return invokeObjcSelf!(void, "set");
	}

}

